LeetCode(198) House Robber

来源:互联网 发布:c语言调用大漠插件 编辑:程序博客网 时间:2024/06/11 18:45

题意:给一组非负整数,不能同时取相邻的两个数,求它们的和的最大值。

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed, the only constraint stopping you from robbing each of them is that adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

解法:动态规划,f(i)表示只取前i个数能够得到的最大值。因为不能取连续的两个数,所以如果取第i个数,就不能取第i-1个数。

f(i)=max(f[i-1],f[i-2]+A[i])。

复杂度:O(n).

代码:

class Solution {public:    int rob(vector<int>& nums) {        int n=nums.size();        if(n==0) return 0;        vector<int> dp(n);        dp[0]=nums[0];        dp[1]=max(nums[0],nums[1]);        for(int i=1;i<n;i++) dp[i]=max(dp[i-1],dp[i-2]+nums[i]);        return dp[n-1];    }};


0 0
原创粉丝点击